% load song
song = wavread('PSY-GANGNAMSTYLE-8000.wav');
%song = wavread('Mozart.wav');

fs = 8000;

% strip stereo
song = song(:,1);

% record clip
clipRec = audiorecorder(fs,24,1);

disp('Recording...');
recordblocking(clipRec,2);
tic
disp('Processing...');


clip = getaudiodata(clipRec);

% run correlation

c = conv(clip(end:-1:1), song);

[maxVal, location] = max(c);

% take the first max in case there are two
location = location(1);

elapsedTime = toc;
tic
startLocation = location + elapsedTime*fs + 3000;

disp(['Time: ' num2str(location/fs) ' + ' num2str(elapsedTime)]);

% start playing the song at the correct location

playerObj = audioplayer(song(startLocation:end), fs);

disp('Playing... press enter to stop.');

play(playerObj);
toc
pause

stop(playerObj);